<?php
/**
 * @wordpress-plugin
 * Plugin Name:       Contact forms anti spam
 * Plugin URI:        https://www.siteix.co.il
 * Description:       Blacklist words for elementor + CF7 forms, Block specipic words,Ip,Country And more...
 * Version:           0.2.0
 * Author:            yonifre
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       contact-forms-anti-spam
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Currently plugin version.
 */
define( 'SETTINGS_PAGE_VERSION', '0.2.0' );

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-settings-page-activator.php
 */
// For future version
function activate_elementor_forms_anti_spam() {
	//require_once plugin_dir_path( __FILE__ ) . 'includes/class-efas-activator.php';
	//Settings_Page_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-settings-page-deactivator.php
 */
// For future version
function deactivate_elementor_forms_anti_spam() {
	//require_once plugin_dir_path( __FILE__ ) . 'includes/class-efas-deactivator.php';
	//Settings_Page_Deactivator::deactivate();
}

//register_activation_hook( __FILE__, 'activate_efas' );
//register_deactivation_hook( __FILE__, 'deactivate_efas' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-efas.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_plugin_elementor_forms_anti_spam() {

	$plugin = new elementor_forms_anti_spam();
	$plugin->run();

}
run_plugin_elementor_forms_anti_spam();

add_filter( 'plugin_row_meta', 'efas_plugin_row_meta', 10, 2 );
function efas_plugin_row_meta( $links, $file ) {
	if( strpos( $file, basename(__FILE__) ) ) {
		$leads_link = array(
			'donat_link' => '<a href="https://paypal.me/yonifre" target="_blank">'.__( 'Donat', 'elementor-forms-anti-spam' ).'</a>',
			'settings' => '<a href="'.admin_url().'admin.php?page=elementor_forms_anti_spam" target="_blank">'.__( 'Setting page', 'elementor-forms-anti-spam' ).'</a>',
		);
		
		$links = array_merge( $links, $leads_link );
	}
	
	return $links;
}

add_filter( 'admin_footer_text', 'efas_admin_footer_text' ,50 );
function efas_admin_footer_text($footer_text){
  $current_screen = get_current_screen();
  $is_efas_screen = ( $current_screen && false !== strpos( $current_screen->id, 'anti_spam' ) );
  if($is_efas_screen){
   	$footer_text = "Spread love in the world <span class='dashicons dashicons-heart'></span>";
  }
  return $footer_text;
  }