<?php
/*
* CF7 Hooks
*/

add_filter( 'wpcf7_validate', 'efas_wpcf7_validate_process' , 10, 2 );
function efas_wpcf7_validate_process ( $result, $tags ) {
  
 
 
  $spamcounter = get_option( 'spamcounter' ) ? get_option( 'spamcounter' ) : 0;
  $error_message = get_option( 'error_message' ) ? get_option( 'error_message' ) : "Look like a spam, Try again";
    /*
  // lang check
  if ($hebrewneeded){
    $havehebrew = false;
    $field_id = '1';
    $types_to_check = array('text','textarea');
    foreach($tags as $key => $tag){
    	$types = $tag['type'];
      	$types = preg_replace("*", "", $types );

if( in_array($types_to_check , $types) ){
  
}  
	$name = $tag['name'];
	$the_value = $_POST[$name];

      $field_value = $the_value;  
      $body .= "<br>".print_r($types , true);
      if (efas_is_hebrew($field_value)) {
        $havehebrew = true;
        $body .= "_yes";
      }
    }
    wp_mail( $to, $subject, $body, $headers );
    if(!$havehebrew){
      update_option( 'spamcounter', ++$spamcounter );
      $result['valid'] = false;
      $result->invalidate( $tags, "יש להכניס תוים בעברית" );

    }
  }*/
  $reversed = array_reverse($tags);

  $tag = $tags ? new WPCF7_FormTag(  $reversed[1]  ) : null;
  $name = ! empty( $tag ) ? $tag->name : null;
  $id = $tag->get_id_option();

  // ip
  $ip = efas_getRealIpAddr();
  $ip_blacklist =  get_option( 'ip_blacklist' );
  // country
  $xml = simplexml_load_file("http://www.geoplugin.net/xml.gp?ip=".$ip);
  $countryName = $xml ? strtolower($xml->geoplugin_countryName) : false ;
  $country_blacklist =  strtolower(get_option( 'country_blacklist' ));
  if (strpos($country_blacklist, $countryName) !== false || strpos($ip_blacklist, $ip) !== false ) {
    $ip_country_blacklist = true;
  }
    //If country or ip is in blacklist
  if ( $ip_country_blacklist ) {
      update_option( 'spamcounter', ++$spamcounter );
      efas_add_to_log($type = "Country/IP","$countryName/$ip is blacked" );
          $result['valid'] = false;
      	  $result->invalidate( $tag, $error_message );
  	}
	return $result;
}


// Add custom validation for CF7 text fields
function efas_cf7_text_validation_filter($result,$tag){
	$type = $tag['type'];
	$name = $tag['name'];
	$the_value = $_POST[$name];
	
  	$spamcounter = get_option( 'spamcounter' ) ? get_option( 'spamcounter' ) : 0;
  	$field_value = strtolower($the_value); 
    if(!$field_value){
      return $result;
    }
    $error_message = get_option( 'error_message' ) ? get_option( 'error_message' ) : "Look like a spam, Try again";
    $text_blacklist = get_option( 'text_blacklist' ) ? efas_makeArray(get_option('text_blacklist') ) : array('eric jones');
     if( is_array($text_blacklist) ){
       foreach ($text_blacklist as $bad_string) {
        if( efas_is_field_value_equwl_to_string($bad_string, $field_value) ) {
          update_option( 'spamcounter', ++$spamcounter );
           efas_add_to_log($type = "text",$field_value);
          $result['valid'] = false;
      	  $result->invalidate( $tag, $error_message );
        }
       }
    }
	return $result;
}
add_filter('wpcf7_validate_text','efas_cf7_text_validation_filter', 10, 2); // Normal field
add_filter('wpcf7_validate_text*', 'efas_cf7_text_validation_filter', 10, 2); // Req. field

// Add custom validation for CF7 email fields
function efas_cf7_email_validation_filter($result,$tag){
	$type = $tag['type'];
	$name = $tag['name'];
	$the_value = $_POST[$name];
	
  	$spamcounter = get_option( 'spamcounter' ) ? get_option( 'spamcounter' ) : 0;
  	$field_value = strtolower($the_value); 
    if(!$field_value){
      return $result;;
    }
    $error_message = get_option( 'error_message' ) ? get_option( 'error_message' ) : "Look like a spam, Try again";
    $text_blacklist =  efas_makeArray( get_option('emails_blacklist') ) ;
     if( is_array($text_blacklist) ){
       foreach ($text_blacklist as $bad_string) {
        if( efas_is_field_value_equwl_to_string($bad_string, $field_value) ) {
          update_option( 'spamcounter', ++$spamcounter );
          efas_add_to_log($type = "email",$field_value);
          $result['valid'] = false;
      	  $result->invalidate( $tag, $error_message );
        }
       }
    }
	return $result;
}
add_filter('wpcf7_validate_email','efas_cf7_email_validation_filter', 10, 2); // Normal field
add_filter('wpcf7_validate_email*', 'efas_cf7_email_validation_filter', 10, 2); // Req. field

// Add custom validation for CF7 tel fields
function efas_cf7_tel_validation_filter($result,$tag){
	$type = $tag['type'];
	$name = $tag['name'];
	$the_value = $_POST[$name];
	
  	$field_value = strtolower($the_value); 
  	$spamcounter = get_option( 'spamcounter' ) ? get_option( 'spamcounter' ) : 0;
    if($field_value == "" || !$field_value ){
		return $result;
    }
    $error_message = get_option( 'error_message' ) ? get_option( 'error_message' ) : "Look like a spam, Try again";
    $tel_formats = efas_makeArray(get_option( 'tel_formats' ));
    $valid = true;
    if( is_array($tel_formats) ){
      $valid = false;
      foreach ($tel_formats as $format) {
        if ( preg_match( $format, $field_value ) ) {
          $valid = true;
          break;
        }
      }
      if(!$valid){
          $result['valid'] = false;
      	  $result->invalidate( $tag, $error_message );
      }
    } 
	return $result;
}
add_filter('wpcf7_validate_tel','efas_cf7_tel_validation_filter', 10, 2); // Normal field
add_filter('wpcf7_validate_tel*', 'efas_cf7_tel_validation_filter', 10, 2); // Req. field

// Add custom validation for CF7 textarea fields
function efas_cf7_textarea_validation_filter($result,$tag){
	$type = $tag['type'];
	$name = $tag['name'];
	$the_value = $_POST[$name];
  	$field_value = strtolower($the_value); 
  	$spamcounter = get_option( 'spamcounter' ) ? get_option( 'spamcounter' ) : 0;
    if($field_value == "" || !$field_value ){
		return $result;
    }
    $error_message = get_option( 'error_message' ) ? get_option( 'error_message' ) : "Look like a spam, Try again";
  
    $textarea_blacklist = efas_makeArray(get_option( 'textarea_blacklist' ));
    foreach ($textarea_blacklist as $bad_string) {
      if(efas_is_field_value_exist_in_string($bad_string, $field_value)) {
        update_option( 'spamcounter', ++$spamcounter );
        efas_add_to_log($type = "textarea","field_value include $bad_string");
        $result['valid'] = false;
      	$result->invalidate( $tag, $error_message );
        return $result;
      }
    }
  
  	//contain_links
    $max_links = get_option( 'contain_links' );
    if ( $max_links ) {
      $reg_exUrl = "/(http|https)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/";
	  $num_links = preg_match_all( $reg_exUrl, $field_value );
		if ( $num_links >= $max_links ) {
          update_option( 'spamcounter', ++$spamcounter );
          efas_add_to_log($type = "textarea","contain more then  $max_links links");
          $result['valid'] = false;
      	  $result->invalidate( $tag, $error_message );
          return $result;
		}
	}
  
	return $result;
}
add_filter('wpcf7_validate_textarea','efas_cf7_textarea_validation_filter', 10, 2); // Normal field
add_filter('wpcf7_validate_textarea*', 'efas_cf7_textarea_validation_filter', 10, 2); // Req. field