<?php
/*
* Main function
*/
function efas_get_browser_name($user_agent)
{
        // Make case insensitive.
        $t = strtolower($user_agent);

        // If the string *starts* with the string, strpos returns 0 (i.e., FALSE). Do a ghetto hack and start with a space.
        // "[strpos()] may return Boolean FALSE, but may also return a non-Boolean value which evaluates to FALSE."
        //     http://php.net/manual/en/function.strpos.php
        $t = " " . $t;

        // Humans / Regular Users     
        if     (strpos($t, 'opera'     ) || strpos($t, 'opr/')     ) return 'Opera'            ;
        elseif (strpos($t, 'edge'      )                           ) return 'Edge'             ;
        elseif (strpos($t, 'chrome'    )                           ) return 'Chrome'           ;
        elseif (strpos($t, 'safari'    )                           ) return 'Safari'           ;
        elseif (strpos($t, 'firefox'   )                           ) return 'Firefox'          ;
        elseif (strpos($t, 'msie'      ) || strpos($t, 'trident/7')) return 'Internet Explorer';

        // Search Engines 
        elseif (strpos($t, 'google'    )                           ) return '[Bot] Googlebot'   ;
        elseif (strpos($t, 'bing'      )                           ) return '[Bot] Bingbot'     ;
        elseif (strpos($t, 'slurp'     )                           ) return '[Bot] Yahoo! Slurp';
        elseif (strpos($t, 'duckduckgo')                           ) return '[Bot] DuckDuckBot' ;
        elseif (strpos($t, 'baidu'     )                           ) return '[Bot] Baidu'       ;
        elseif (strpos($t, 'yandex'    )                           ) return '[Bot] Yandex'      ;
        elseif (strpos($t, 'sogou'     )                           ) return '[Bot] Sogou'       ;
        elseif (strpos($t, 'exabot'    )                           ) return '[Bot] Exabot'      ;
        elseif (strpos($t, 'msn'       )                           ) return '[Bot] MSN'         ;

        // Common Tools and Bots
        elseif (strpos($t, 'mj12bot'   )                           ) return '[Bot] Majestic'     ;
        elseif (strpos($t, 'ahrefs'    )                           ) return '[Bot] Ahrefs'       ;
        elseif (strpos($t, 'semrush'   )                           ) return '[Bot] SEMRush'      ;
        elseif (strpos($t, 'rogerbot'  ) || strpos($t, 'dotbot')   ) return '[Bot] Moz or OpenSiteExplorer';
        elseif (strpos($t, 'frog'      ) || strpos($t, 'screaming')) return '[Bot] Screaming Frog';
       
        // Miscellaneous
        elseif (strpos($t, 'facebook'  )                           ) return '[Bot] Facebook'     ;
        elseif (strpos($t, 'pinterest' )                           ) return '[Bot] Pinterest'    ;
       
        // Check for strings commonly used in bot user agents  
        elseif (strpos($t, 'crawler' ) || strpos($t, 'api'    ) ||
                strpos($t, 'spider'  ) || strpos($t, 'http'   ) ||
                strpos($t, 'bot'     ) || strpos($t, 'archive') ||
                strpos($t, 'info'    ) || strpos($t, 'data'   )    ) return '[Bot] Other'   ;
       
        return 'Other (Unknown)';
}
function efas_add_to_log($type,$input) {
   $emptylog = '{ 
	"spammer":[
    {
        "Type":"",
        "value":"",
        "Ip":"",
        "Country":"",
        "User agent":"",
        "Date":"",
   },
  ]}';
  $errorlog = get_option( 'errorlog' ) ? get_option( 'errorlog' ) : $emptylog;
  
  $ip = efas_getRealIpAddr();
  $xml = simplexml_load_file("http://www.geoplugin.net/xml.gp?ip=".$ip);
  $countryName = $xml ? strtolower($xml->geoplugin_countryName) : "Other (Unknown)" ;
  $user_agent = $_SERVER['HTTP_USER_AGENT'];
  $browser_name = efas_get_browser_name($user_agent);  
  $date = wp_date("d-m-Y H:i:s", null, wp_timezone() );;
  $arr = json_decode($errorlog, TRUE);
  $arr[] =['Type' => $type,'value' => $input, 'Ip' => $ip, 'Country' => $countryName, 'User agent' => $browser_name, 'Date' => $date];
  $json = json_encode($arr);
  update_option( 'errorlog',$json );
}

function build_table($array){
    // start table
    $html = '<table style="
    width: 80%;
    border-spacing: 0px;
    padding: 20px 0;
">';
    // header row
    $html .= '<tr>';
  	$count = count($array) - 1;
    foreach($array[$count] as $key=>$value){
            $html .= '<th style="
    border: 1px solid #333;
    padding: 3px ;
">' . htmlspecialchars($key)  .  '</th>';
        }
    $html .= '</tr>';

    // data rows
    foreach( $array as $key=>$value){
        $html .= '<tr >';
        foreach($value as $key2=>$value2){
            $html .= '<td style=" border: 1px solid #333; padding: 5px ;text-align: start;">' . htmlspecialchars($value2) . '</td>';
        }
        $html .= '</tr>';
    }

    // finish table and return it

    $html .= '</table>';
    return $html;
}

function efas_getRealIpAddr() {
    if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
    {
      $ip=$_SERVER['HTTP_CLIENT_IP'];
    }
    elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
    {
      $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
    }
    else
    {
      $ip=$_SERVER['REMOTE_ADDR'];
    }
    return $ip;
}
function efas_makeArray($string){
  if(  !$string ){
    return array("empty");
  }
  $string = strtolower($string);
  // to improve 
	return explode("\n", str_replace("\r", "", $string));
}
function efas_is_field_value_exist_in_string($string,$field_value){
  if( $string == "" || !$input == "" ){
    return false;
  }
  $string = strtolower($string);
  if(strpos($field_value, $string) !== false) {
        return true;
  }
  // to improve 
	return false;
}

function efas_is_field_value_equwl_to_string($string,$field_value){
  if(  $string == "" || !$input == "" ){
    return false;
  }
  $string = strtolower($string);
  if (strpos($string, $field_value) !== false) {
  	return true;
  }
	return false;
}

function efas_is_hebrew($string){
    return preg_match("/\p{Hebrew}/u", $string);
}